{{
*****************************************
* RFM12 Receiver Demo                   *
* Author: Marcello Campione             *
* Copyright (c) 2009-2010               *
*                                       *
* You may freely use and modify this    *
* programm, but you must keep my name   *
* in the authors list.                  *
*****************************************
}}


CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000

OBJ
SPI     :       "ShiftOut&In2"                             ''The Standalone SPI Spin engine
term    :       "PC_Interface"


CON

{
' PCB
nSEL    = 25 
SCK     = 26 
SDI     = 27
SDO     = 20

LED     = 14'16
'nIRQ    = 13
}

'Protoboard
nSEL    = 11
SCK     = 12
SDI     = 13

SDO     = 14
nIRQ    = 15
FFIT    = 15

LED     = 16


CommandDelay = 100

WAIT    = 1
NOWAIT  = 0


Terminal = 0

Var
  Byte InData[10]
  long i,ReceivedValue


PUB SPI_DEMO


''SPI Setup                      
  SPI.Start(SCK,SDI,SDO,nSEL)
  waitcnt(cnt+clkfreq/10)            


     
    
      DirA[nIRQ]:=0
      DirA[LED]:=1
      Outa[LED]:=0

      'OutA[nSEL]:=1
      'DirA[nSEL]:=1

      'OutA[SDI]:=1
      'DirA[SDI]:=1

      'OutA[SCK]:=0
      'DirA[SCK]:=1

      DirA[SDO]:=0

    

      repeat 2
         !Outa[LED]
         waitcnt(cnt+clkfreq/20)


      if Terminal == 1
              term.start(31,30)
               
              repeat while term.abs_x == 0    'wait for PropTerminal.exe started
                  
                !outa[LED]
                waitcnt(cnt + clkfreq/10)
               
              outa[LED]:=0
               
              'setpos(0,0)
              'term.setcol(YELLOW)
              term.str(string("RFM12 Receive in Assembler",13))
              'term.setcol(BLUE)
              term.str(string("Marcello Campione (C) 2009-2010",13))
              'term.setcol(GREEN)   

      
      waitcnt(cnt+clkfreq/10)


      SendCMD($0000,NOWAIT)  

      SendCMD($80D7,NOWAIT)            'FIFO & Base Freq  $80D7
      
      SendCMD($82C9,NOWAIT)            'Power Receiver

      SendCMD($AF3F,NOWAIT)            'Tx Freq. 433,92                                                   s

      SendCMD($C604,NOWAIT)            'Data Rate $C628 = MAX in SPI  A60A =OK  $C603 = Mas Ass 

      SendCMD($9460,NOWAIT)            'Receiver Control Command 94c0 va peggio a baud alti Banda larga = 9460     
                           
      SendCMD($C2aC,NOWAIT)            'Digital Filter, Clock Recovery & DQD Therhold

      SendCMD($CA81,NOWAIT)            'FIFO Mode = FIFO Disabled

      SendCMD($C493,NOWAIT)            'AFC Config   $C493

      SendCMD($9823,NOWAIT)            'AFC Freq Deviation 90 Khz, Max Out Power $9823

      SendCMD($E000,NOWAIT)            'AFC

      SendCMD($C800,NOWAIT)            'AFC

      SendCMD($C000,NOWAIT)            'Battery

 
      repeat  10
         !Outa[LED]
         waitcnt(cnt+clkfreq/30)

         
      SendCMD($82C9,NOWAIT)            'FIFO Off
      waitcnt(cnt+clkfreq/CommandDelay)
       
      SendCMD($CA83,NOWAIT)            'FIFO On
      waitcnt(cnt+clkfreq/CommandDelay)
      'term.str(string("Ready !",13))

      
       
      repeat
          i:=0  
          repeat 2
             SPI.SHIFTOUT(SPI#SPI_nSELLowWait,0)      
             'repeat while InA[SDO]==0   
             'SPI.SHIFTOUT(SPI#SPI_nSELHigh,0)          
             InData[i++] := SPI.SHIFTOUT(SPI#SPI_SEND,$B000) 

             'InData[i++] := ReceiveCMD($B000) & 255     
             
          'Outa[LED]:=1   
          
          SendCMD($CA81,NOWAIT)        'FIFO fill off
          'SendCMD($82C9,NOWAIT)           'Power

          if InData[0] == 16 and InData[1] == 1
              Outa[LED]:=1
                                                        
          if Terminal == 1
              i:=0
              repeat 6
                  term.dec(InData[i++])
                  term.str(string(" "))
              term.str(string(" ",13))
       
          SendCMD($CA83,NOWAIT)        'FIFO On
          waitcnt(cnt+clkfreq/10)               
          Outa[LED]:=0     
          
          




Pub SendCMD(Command, _Wait)
  
  
  'OutA[SCK]:=0
  'OutA[nSEL]:=0
  

     SPI.SHIFTOUT(SPI#SPI_SEND,Command) 

     
     'SPI.SHIFTOUT(SPI#SPI_nSELLow,0)     
     'if _wait == 1
        'SPI.SHIFTOUT(SPI#SPI_nSELLowWait,0)     
      '  repeat while InA[SDO] == 0
     'SPI.SHIFTOUT(SPI#SPI_nSELHigh,0)         
           

  'OutA[SCK]:=0
  'OutA[nSEL]:=1

      


Pub ReceiveCMD(Command): Value


  'OutA[SCK]:=0
  'OutA[nSEL]:=0
 

     Value := SPI.SHIFTOUT(SPI#SPI_SEND,Command) 

     'SPI.RFM12SHIFTOUTIN(SDI, SDO, SCK, 16, Command)

  
  'OutA[SCK]:=0
  'OutA[nSEL]:=1
  return Value  

  
        
        
PUB HIGH(Pin)
    dira[Pin]~~
    outa[Pin]~~
         
PUB LOW(Pin)
    dira[Pin]~~
    outa[Pin]~




 { SAFE CONFIGURATION 
      SendCMD($0000,NOWAIT)  

      SendCMD($80D7,NOWAIT)            'FIFO & Base Freq  $80D7
      
      SendCMD($82C9,NOWAIT)            'Power Receiver

      SendCMD($AF3F,NOWAIT)            'Tx Freq. 433,92

      SendCMD($C647,NOWAIT)            'Data Rate C67f= 2.6kbs     

      SendCMD($94C4,NOWAIT)            'Receiver Control Command     
                           
      SendCMD($C2AC,NOWAIT)            'Digital Filter, Clock Recovery & DQD Therhold

      SendCMD($CA81,NOWAIT)            'FIFO Mode = FIFO Disabled

      SendCMD($C493,NOWAIT)            'AFC Config   $C493

      SendCMD($9827,NOWAIT)            'AFC Freq Deviation 90 Khz, Max Out Power

      SendCMD($E000,NOWAIT)            'AFC

      SendCMD($C800,NOWAIT)            'AFC

      SendCMD($C000,NOWAIT)            'Battery

      'SendCMD($C676)            'PLL
      }


 