' Test Program
' ShiftOut & ShiftIn in one


CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000
{
SP_SCK  = 12
SP_NSEL = 11
SP_SDO  = 14
SP_SDI  = 13
 }
SPI_SEND        = 1<<17    
SPI_nSELHigh    = 1<<18
SPI_nSELLow     = 1<<19
SPI_nSELLowWait = 1<<20 
SPI_KILL        = 1<<21   


VAR
    long     cog, Command, Value


Pub Main | i

  dira[16]:=1       
  i:=0

    
    Start(12,13,14,11)
    'waitcnt(cnt+clkfreq/30)


    
        
    repeat
        SHIFTOUT(SPI_SEND,17)
         '!outa[16]  
        waitcnt(cnt+clkfreq/100)

    

    repeat 
       SHIFTOUT(SPI_nSELHigh,102)
       !outa[16]
        waitcnt(cnt+clkfreq/1000)
       SHIFTOUT(SPI_nSELLow,100)
       !outa[16]
        waitcnt(cnt+clkfreq/1000) 


    SHIFTOUT(SPI_KILL,100)
    
        
   
    
    
    
    repeat
     
'------------------------------------------------------------------------------------------------------------------------------
PUB ShiftOut(_Command, _Value) : ReturnValue


           Value := _Value     
           Command := _Command '_Command+Value                     ' Start doing in the assembler cog

           Repeat until Command == 0

 return  Value 




PUB Start(_SCK,_SDI,_SDO,_nSEL): okay     '(Delay,State) : okay


'' Start SPI Engine - starts a cog
'' returns false if no cog available

    p_sck  :=   1<<_SCK    
    p_nsel :=   1<<_NSEL
    p_sdo  :=   1<<_SDO
    p_sdi  :=   1<<_SDI


    Command := 0
    Value:=0
    
    okay := cog := cognew(@Init, @command) + 1

return okay
  
    
PUB stop
'' Stop SPI Engine - frees a cog
    if cog
       cogstop(cog~ - 1)
    command~


 

DAT
              org 0

              'mov       Zero, #0        wz      'Z = 1     
Init          andn      outa,   p_sck             'SCK = 0
              or        outa,   p_nsel            'nSEL = 1
              
              mov       Zero,   #0         wz     'Z = 1
              muxz      dira,   p_SDI             'Out
              muxnz     dira,   p_SDO             'In              
              muxz      dira,   p_sck             'Out
              muxz      dira,   p_nsel            'Out
              
              mov       ComAddr,  par               ''Flag Address
              mov       ValueAddr,ComAddr           
              add       ValueAddr, #4                ' Since par address = 14 Bits 
Loop          rdlong    OutValue,  ValueAddr
              rdlong    temp,      ComAddr         wz                ''wait for command
              
        if_z jmp       #Loop

              
              test       temp,  _SendWordBitmask wz        'Z=1 if result == 0
        if_nz call      #SendWord
              test       temp, _nSELHighBitmask wz 
        if_nz call      #nSELHigh
              test       temp, _nSELLowBitmask  wz
        if_nz call      #nSELLow
              test       temp, _nSELLowWaitBitmask  wz
        if_nz call      #nSELLowWait
              test       temp, _KillCog         wz
        if_nz call      #Kill
        
              jmp       #Loop

nSELHigh      or        outa,   p_nSEL            'nSEL High
              wrlong    Zero,   ComAddr                 
nSELHigh_ret  ret


nSELLow       andn      outa,   p_nsel
              wrlong    Zero,   ComAddr     
nSELLow_ret   ret


nSELLowWait   andn      outa,   p_nsel
              
:TestSDO      test      p_SDO,  ina wz
         if_z jmp       #:TestSDO
              or        outa,   p_nSEL            'nSEL High  
              wrlong    Zero,   ComAddr     
nSELLowWait_ret   ret      
        
                                           
              'Sets Inputs and Outputs Directions and start status
              
SendWord      andn      outa,   p_sck                'SCK  = 0
              andn      outa,   p_nsel               'nSEL = 0
                   
              mov       BitCounter, #16                 '16 Bits  
        
              
:sendloop     test      OutValue, _16bitmask wz   'get the 16th Bit Value into Z (Z=1 if bit=0) 
              shl       OutValue, #1              'Shift Left
              
              andn      outa,   p_SCK             'Clock Low OK
              muxnz     outa,   p_SDI             'SDI Bit Value = !Z, see above
              
              'call      #ClkDly                   'Timing

              or        outa,   p_SCK             'Clock High
              
              test      p_SDO,  ina wc           'get the SDO value into C = Odd Parity of the result
              shl       InValue, #1  
              muxc      InValue, #1              'put C = SDO into outreg
              
              'call      #ClkDly
                                               
              djnz      BitCounter, #:sendloop          'Decrement da, if not zero jump to :sendloop


'Send finished, go back
              andn      outa,   p_sck                'SCK  = 0
              'call      #ClkDly
              or        outa,   p_nsel               'nSEL = 1
              andn      outa,   p_SDI                'SDI  = 0 
             
              wrlong    InValue, ValueAddr                                  
              wrlong    Zero,     ComAddr             'FLAG = 0 signals that the word has been send  
              
sendword_ret  ret


              
Kill          CogID    temp                                'Read CogID
              COGSTOP  temp                               'Stop this Cog!
Kill_ret      ret              
              


ClkDly        mov       time,     ClockDelay
ClkPause      djnz      time,     #ClkPause                               
ClkDly_ret    ret




p_sck         long      0'1<<SP_SCK    
p_nsel        long      0'1<<SP_NSEL
p_sdo         long      0'1<<SP_SDO
p_sdi         long      0'1<<SP_SDI
Zero          long      0


_16bitmask              long 1<<15    

_SendWordBitmask        long 1<<17
_nSELHighBitmask        long 1<<18
_nSELLowBitmask         long 1<<19
_nSELLowWaitBitmask     long 1<<20 
_KillCog                long 1<<21      
    

BitCounter              long    0
time                    long    0
Temp                    long    0


ClockDelay              long    2                ' More or less one Mhz


InValue                 long    0
OutValue                long    0  
ComAddr                 long    0
ValueAddr               long    0    